#********************************************************************************
# qemud - simple wrapper script to start multiple qemu virtual machines         *
#                                                                               *
#  Author: Kai Peter, ©2016-                                                    *
# Version: 0.34                                                                 *
# License: ISC                                                                  *
#                                                                               *
# Description: qemud is a wrapper to handle links of qemu-init. Commonly it is  *
#              a link in '/etc/init.d' (recommended).                           *
#********************************************************************************

usage() { echo "Usage: "`basename $0`" start|stop|status" ; exit 1 ; }

[ $1 ] || usage
[ $2 ] && usage
[ $1 = "start" ] || [ $1 = "stop" ] || [ $1 = "status" ] || usage

autostart() {
  [ "$1" = "start" ] || return
  AUTOSTART=`echo "$AUTOSTART" | tr '[A-Z]' '[a-z]'`
  [ "$AUTOSTART" = "y"   ] && AUTOSTART=1
  [ "$AUTOSTART" = "on"  ] && AUTOSTART=1
  [ "$AUTOSTART" = "yes" ] && AUTOSTART=1
  [ "$AUTOSTART" = "1" ] || VM=""
}

CFF="REGFILE"
[ ! -f "$CFF" ] && echo "Config file '$CFF' not found! Aborting!" && exit

export QEMUD=1
while IFS= read L ; do
  VM=$(echo "$L" | grep -v '^#' | cut -d: -f1)
  AUTOSTART=$(echo "$L" | cut -d: -f2)
  [ "$AUTOSTART" ] && autostart "$1"
#[ "$AUTOSTART" = 1 ] && echo A: $AUTOSTART  $VM
  if [ -n "$VM" ] && [ -f "$VM" ] ; then qemu-init "$VM" "$1" ; fi
done < "$CFF"
